; 

    include \masm32\include\masm32rt.inc

    dlgproc PROTO :DWORD,:DWORD,:DWORD,:DWORD

    .data?
      WM_APPNOTIFY dd ?

    .code

; 

start:

      GLOBAL hButn1     dd ?
      GLOBAL hButn2     dd ?
      GLOBAL hProgress  dd ?
      GLOBAL hInstance  dd ?
      GLOBAL hIcon      dd ?

      invoke InitCommonControls

      mov hInstance, FUNC(GetModuleHandle,NULL)
      mov hIcon,     FUNC(LoadIcon,hInstance,500)

      call main

    ; **************************************************
      invoke PostMessage,HWND_BROADCAST,WM_APPNOTIFY,0,0
    ; **************************************************

      invoke ExitProcess,eax

; 

main proc

    LOCAL lpArgs:DWORD

    invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT, 32
    mov lpArgs, eax

    push hIcon
    pop [eax]

    Dialog "This is progress","MS Sans Serif",10, \         ; caption,font,pointsize
            WS_OVERLAPPED or DS_CENTER, \                   ; style
            1, \                                            ; control count
            50,50,150,40, \                                 ; x y co-ordinates
            1024                                            ; memory buffer size

    DlgProgress PBS_SMOOTH or WS_BORDER,3,10,141,9,102

    CallModalDialog hInstance,0,dlgproc,ADDR lpArgs

    invoke GlobalFree, lpArgs

    ret

main endp

; 

dlgproc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL cnt:DWORD

    .if uMsg == WM_INITDIALOG
      invoke GetDlgItem,hWin,102
      mov hProgress, eax

      invoke SendMessage,hProgress,PBM_SETRANGE32,0,100
      invoke SendMessage,hProgress,PBM_SETBKCOLOR,0,00000000h  ; black
      invoke SendMessage,hProgress,PBM_SETBARCOLOR,0,00FF0000h ; blue
    ; ************************************************************
      mov WM_APPNOTIFY, rv(RegisterWindowMessage,"WM_APPNOTIFY")
    ; ************************************************************

    .elseif uMsg == WM_SETFOCUS
      invoke PostMessage,hWin,WM_COMMAND,IDOK,0

    .elseif uMsg == WM_COMMAND
      .if wParam == IDOK
        mov cnt, 0

      @@:
        invoke Sleep,25
        invoke SendMessage,hProgress,PBM_SETPOS,cnt,0
        add cnt, 1
        cmp cnt, 100
        jle @B

        invoke PostMessage,hWin,WM_COMMAND,IDCANCEL,0

      .elseif wParam == IDCANCEL
        jmp quit_dialog
      .endif

    .elseif uMsg == WM_CLOSE
      quit_dialog:
      invoke EndDialog,hWin,0

    .endif

    xor eax, eax
    ret

dlgproc endp

; 

end start